/***************************************************************/
/* Dustin Graves                                               */
/* CSCI 185 10                                                 */
/* 9/16/98                                                     */
/* 9/30/98                                                     */
/* 10/14/98                                                    */
/***************************************************************/

import java.awt.*;

abstract class MyGraphicalObject
{

  //Instance methods

  //Currently represent width and height of canvas
  //Max values of width-1 and height-1
  public static int MaxX;
  public static int MaxY;
  public static int MaxZ;

  //Instance methods

  //Method to do Cartesian to pixel conversions for X axis
  protected static int xToScreen (double x)
  {
    return (int) Math.round (x * ((double) MaxX));
  } //xToScreen

  //Method to do Cartesian to pixel conversions for Y axis
  //without directional adjustment
  protected static int yToScreenRaw (double y)
  {
    return (int) Math.round (y * ((double) MaxY));
  } //yToScreenRaw

  //Method to do Cartesian to pixel conversions for Y axis
  protected static int yToScreen (double y)
  {
    return (MaxY - yToScreenRaw (y));
  } //yToScreen

  //Method to do Cartesian to pixel conversions for Z axis
  protected static int zToScreen (double z)
  {
    return (int) Math.round (z * ((double) MaxZ));
  } //zToScreen

  //Method to do world to normalized Cartesian conversions for X axis
  protected static double xToNormalized (double x)
  {
    return (x / ((double)MaxX));
  } //xToNormalized

  //Method to do world to normalized Cartesian conversions for Y axis
  protected static double yToNormalized (double y)
  {
    return (y / ((double)MaxY));
  } //yToNormalized

  //Method to do world to normalized Cartesian conversions for Z axis
  protected static double zToNormalized (double z)
  {
    return (z / ((double)MaxZ));
  } //zToNormalized

  //Pure virtual render method
  public abstract void render (Graphics g);

  //Pure virtual transformation apply method
  public abstract void apply (Xform x);

} //MyGraphicalObject
