/***************************************************************/
/* Dustin Graves                                               */
/* CSCI 185 10                                                 */
/* 9/16/98                                                     */
/* 9/30/98                                                     */
/* 10/14/98                                                    */
/***************************************************************/

import java.awt.*;

class MyLine extends MyGraphicalObject
{

  protected boolean fIs3d;
  protected Point2d fP02d,
                    fP12d;
  protected Point3d fP03d,
                    fP13d;
 
  MyLine (double x0, double y0, double x1, double y1)
  {
    fP02d = new Point2d (x0, y0);
    fP12d = new Point2d (x1, y1);
    fIs3d = false;
  } //MyLine

  MyLine (double x0, double y0, double z0, double x1, double y1, double z1)
  {
    fP03d = new Point3d (x0, y0, z0);
    fP13d = new Point3d (x1, y1, z1);
    fIs3d = true;
  } //MyLine

  public void render (Graphics g)
  {
    //Render line
    if (fIs3d)
    {
      g.drawLine (xToScreen (fP03d.fX), yToScreen (fP03d.fY), 
                  xToScreen (fP13d.fX), yToScreen (fP13d.fY));
    }
    else
    {
      g.drawLine (xToScreen (fP02d.fX), yToScreen (fP02d.fY), 
                  xToScreen (fP12d.fX), yToScreen (fP12d.fY));
    }
  } //render

  public void apply (Xform x)
  {
    //Apply transformation to end points
    if (fIs3d)
    {
      x.apply (fP03d);
      x.apply (fP13d);
    }
    else
    {
      x.apply (fP02d);
      x.apply (fP12d);
    }
  } //apply

} //MyLine
